#!/bin/csh

cd RES
  set listc1="csa_1d.output css_1d.output"
  foreach file ($listc1)
    if ( -f $file ) then
      diff ../MASTER/c1d.master $file >& tmp
      set name=`basename $file .output`
      if ( -z tmp ) then
        echo "$name : OK"
      else
        echo "$name : NG"
        mv tmp ${name}.log
      endif
    endif
  end

  set listz1="zsa_1d.output zss_1d.output"
  foreach file ($listz1)
    if ( -f $file ) then
      diff ../MASTER/z1d.master $file >& tmp
      set name=`basename $file .output`
      if ( -z tmp ) then
        echo "$name : OK"
      else
        echo "$name : NG"
        mv tmp ${name}.log
      endif
    endif
  end

  set listc2="csa_2d.output"
  foreach file ($listc2)
    if ( -f $file ) then
      diff ../MASTER/c2d.master $file >& tmp
      set name=`basename $file .output`
      if ( -z tmp ) then
        echo "$name : OK"
      else
        echo "$name : NG"
        mv tmp ${name}.log
      endif
    endif
  end

  set listz2="zsa_2d.output"
  foreach file ($listz2)
    if ( -f $file ) then
      diff ../MASTER/z2d.master $file >& tmp
      set name=`basename $file .output`
      if ( -z tmp ) then
        echo "$name : OK"
      else
        echo "$name : NG"
        mv tmp ${name}.log
      endif
    endif
  end

  set listc3="csa_3d.output"
  foreach file ($listc3)
    if ( -f $file ) then
      diff ../MASTER/c3d.master $file >& tmp
      set name=`basename $file .output`
      if ( -z tmp ) then
        echo "$name : OK"
      else
        echo "$name : NG"
        mv tmp ${name}.log
      endif
    endif
  end

  set listz3="zsa_3d.output"
  foreach file ($listz3)
    if ( -f $file ) then
      diff ../MASTER/z3d.master $file >& tmp
      set name=`basename $file .output`
      if ( -z tmp ) then
        echo "$name : OK"
      else
        echo "$name : NG"
        mv tmp ${name}.log
      endif
    endif
  end

  set listerfb1="*er_fbw1_1d.output"
  foreach file ($listerfb1)
    if ( -f $file ) then
      set line=`grep "Descriptor is not committed" $file | wc -l`
      set name=`basename $file .output`
      if ( $line == 2 ) then
        set linew=`grep "bad_desc" $file | grep "2" | wc -l`
        if ( $linew == 2 ) then
          echo "$name : OK"
        else
          echo "$name : NG"
        endif
      else
        echo "$name : NG"
      endif
    endif
  end

  set listerfb2="*er_fbw2_1d.output"
  foreach file ($listerfb2)
    if ( -f $file ) then
      set line=`grep "Invalid dimension." $file | wc -l`
      set name=`basename $file .output`
      if ( $line == 2 ) then
        set linew=`grep "bad_desc" $file | grep "5" | wc -l`
        if ( $linew == 2 ) then
          echo "$name : OK"
        else
          echo "$name : NG"
        endif
      else
        echo "$name : NG"
      endif
    endif
  end

  set listerfb3="*er_fbw3_1d.output"
  foreach file ($listerfb3)
    if ( -f $file ) then
      set line=`grep "More than 3 dimensions are not supported." $file | wc -l`
      set name=`basename $file .output`
      if ( $line == 2 ) then
        set linew=`grep "bad_desc" $file | grep "5" | wc -l`
        if ( $linew == 2 ) then
          echo "$name : OK"
        else
          echo "$name : NG"
        endif
      else
        echo "$name : NG"
      endif
    endif
  end

  set listercm="zer_commit_1d.output"
  foreach file ($listercm)
    if ( -f $file ) then
      set line=`grep "Illegal descriptor" $file | wc -l`
      set name=`basename $file .output`
      if ( $line != 0 ) then
        echo "$name : OK"
      else
        echo "$name : NG"
      endif
    endif
  end

  set lister="zer_nomatch_1d.output"
  foreach file ($lister)
    if ( -f $file ) then
      grep "Illegal descriptor" $file >& tmp
      set name=`basename $file .output`
      if ( -z tmp ) then
        echo "$name : NG"
      else
        echo "$name : OK"
      endif
    endif
  end

  if ( -f tmp ) then
    rm tmp
  endif
cd ../
