/**
 * \license This project is released under the BSD 2-clause license
 *
 * Copyright (C) 2014 Xevolver Project. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * - Redistributions of source code must retain the above copyright
 *   notice, this list of conditions and the following disclaimer.
 *
 * - Redistributions in binary form must reproduce the above copyright
 *   notice, this list of conditions and the following disclaimer in
 *   the documentation and/or other materials provided with the
 *   distribution.
 *    
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#define MKL_ASL_INCLUDED

typedef  long long Int64 ;
typedef  int Int32 ;
typedef  unsigned long long UInt64 ;

typedef struct double_complex
{
  double real;
  double img;
} Complex16;

typedef struct single_complex
{
  float real;
  float img;
} Complex8;

#define MKL2ASL_NO_ERROR                    0
#define MKL2ASL_MEMORY_ERROR                1
#define MKL2ASL_INVALID_CONFIGURATION       2
#define MKL2ASL_INCONSISTENT_CONFIGURATION  3
#define MKL2ASL_MULTITHREADED_ERROR         4  /* Future reserve */
#define MKL2ASL_BAD_DESCRIPTOR              5
#define MKL2ASL_UNIMPLEMENTED               6  /* Future reserve */
#define MKL2ASL_MKL_INTERNAL_ERROR          7
#define MKL2ASL_NUMBER_OF_THREADS_ERROR     8  /* Future reserve */
#define MKL2ASL_1D_LENGTH_EXCEEDS_INT32     9  /* Future reserve */

enum MKL2ASL_CONFIG_PARAM
{
  MKL2ASL_PLACEMENT = 11
};

enum MKL2ASL_CONFIG_VALUE
{
  MKL2ASL_COMMITTED   = 30,
  MKL2ASL_UNCOMMITTED = 31,
  MKL2ASL_COMPLEX     = 32,
  MKL2ASL_REAL        = 33,
  MKL2ASL_SINGLE      = 35,
  MKL2ASL_DOUBLE      = 36,
  MKL2ASL_INPLACE     = 43,
  MKL2ASL_NOT_INPLACE = 44
};
