/**
 * \license This project is released under the BSD 2-clause license
 *
 * Copyright (C) 2014 Xevolver Project. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * - Redistributions of source code must retain the above copyright
 *   notice, this list of conditions and the following disclaimer.
 *
 * - Redistributions in binary form must reproduce the above copyright
 *   notice, this list of conditions and the following disclaimer in
 *   the documentation and/or other materials provided with the
 *   distribution.
 *    
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#define MKL_ASLI32_INCLUDED

#ifndef MKL_ASL_INCLUDED
#include "mkl_asl.h"
#endif

struct MKL2ASL_DESCRIPTOR_S  /* ñѥǥץǡ¤ */
{
  Int32  commit_flag;     /* ǥץcommitƤ뤫 */
  Int32  precision;       /*  */
  Int32  domain;          /*  */
  Int32  dim;             /*  */
  Int32  len_1d;          /* 1ܤѴǿ */
  Int32 *length;          /* Ѵǿ */
  Int32  placement_flag;  /* ϤϤ˾񤭤뤫 */
};

/* ASLؿEXTERN */
/* Fortran */
/* ʣ1ΥաꥨѴ */
extern void cfc1fb_(Int32 *, Complex8 *, Int32 *, Int32 *, Int32 *,
                     float *, Complex8 *, Int32 * );
extern void zfc1fb_(Int32 *, Complex16 *, Int32 *, Int32 *, Int32 *,
                     double *, Complex16 *, Int32 * );
/* ʣ2ΥաꥨѴ */
extern void cfc2fb_(Int32 *, Int32 *, Complex8 *, Int32 *, Int32 *,
                     Int32 *, Int32 *, float *, Complex8 *, Int32 * );
extern void zfc2fb_(Int32 *, Int32 *, Complex16 *, Int32 *, Int32 *,
                     Int32 *, Int32 *, double *, Complex16 *, Int32 * );
/* ʣ3ΥաꥨѴ */
extern void cfc3fb_(Int32 *, Int32 *, Int32 *, Complex8 *, Int32 *,
                     Int32 *, Int32 *, Int32 *, Int32 *, float *,
                     Complex8 *, Int32 * );
extern void zfc3fb_(Int32 *, Int32 *, Int32 *, Complex16 *, Int32 *,
                     Int32 *, Int32 *, Int32 *, Int32 *, double *,
                     Complex16 *, Int32 * );
/* ASLؿEXTERNޤ */
