/**
 * \license This project is released under the BSD 2-clause license
 *
 * Copyright (C) 2014 Xevolver Project. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * - Redistributions of source code must retain the above copyright
 *   notice, this list of conditions and the following disclaimer.
 *
 * - Redistributions in binary form must reproduce the above copyright
 *   notice, this list of conditions and the following disclaimer in
 *   the documentation and/or other materials provided with the
 *   distribution.
 *    
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 */
/* 桼ƥƥؿ */

#include <stdio.h>

#ifndef UTIL_INCLUDED
#include "util.h"
#endif

Int32 __MKL2ASL_check_asl_error(Int32 asl_err)
{
  switch (asl_err)
  {
    case 0 :
    case 1000 :
      /* NO ERROR */
      return MKL2ASL_NO_ERROR;
    case 3000 :
      /* ERROR : N <= 1 */
      /* Υˤãʤ */
      fprintf(stderr, "Internal Error : The size of the transform is invalid\n");
      return MKL2ASL_MKL_INTERNAL_ERROR;
    case 3010 :
      /* ERROR : N > LD */
      /* Υˤãʤ */
      fprintf(stderr, "Internal Error : The size of the transform is smaller than that of the array\n");
      return MKL2ASL_MKL_INTERNAL_ERROR;
    case 3020 :
      /* ERROR : ISW != 0,-1,1 */
      /* Υˤãʤ */
      fprintf(stderr, "Internal Error : Illegal SIGN\n");
      return MKL2ASL_MKL_INTERNAL_ERROR;
    default :
      fprintf(stderr, "Internal Error : Illegal ASL ERROR\n");
      return MKL2ASL_MKL_INTERNAL_ERROR;
  }
}
